/* (C) 2009-2011 Yana */

#define YK0A_PREPROCESS_ONLY
#include "yk0a_internal.h"
#include "yk0a.h"
#include "yk0a_setup.h"

#define CPSR_OFF (YK0A_ARM_CPSR_I | YK0A_ARM_CPSR_M_MASK)
#define CPSR_ON YK0A_ARM_CPSR_M_SYS

#define OFFSET(a) ((a) * 4 + YK0A_CONTEXT_BASE)

	.global yk0a_stack
	.comm yk0a_stack, YK0A_SETUP_STACK_SIZE, YK0A_STACK_ALIGNMENT

	.text
	.balign 4

	.global yk0a_initialize
yk0a_initialize:
	ldr sp, =(yk0a_stack + YK0A_SETUP_STACK_SIZE / YK0A_STACK_ALIGNMENT * YK0A_STACK_ALIGNMENT - YK0A_STACK_ARGUMENT)
	b yk0a_core_initialize

	.global yk0a_exception_interrupt_procedure
yk0a_exception_interrupt_procedure:
	ldr sp, =yk0a_schedule_link
	ldr sp, [sp]
	cmp sp, #0
	beq yk0a_exception_interrupt_procedure_0
	add sp, sp, #OFFSET(0)
	stmia sp!, {r0-r12, sp, lr}^
	stmia sp!, {lr}
	mrs r0, spsr
	stmia sp!, {r0}

yk0a_exception_interrupt_procedure_0:
	ldr sp, =(yk0a_stack + YK0A_SETUP_STACK_SIZE / YK0A_STACK_ALIGNMENT * YK0A_STACK_ALIGNMENT - YK0A_STACK_ARGUMENT)
	bl yk0a_core_exception_interrupt_procedure

	ldr sp, =yk0a_schedule_link
	ldr sp, [sp]
	cmp sp, #0
	beq yk0a_exception_interrupt_procedure_1
	add sp, sp, #OFFSET(17)
	ldmdb sp!, {r0}
	msr spsr, r0
	ldmdb sp!, {lr}
	ldmdb sp!, {r0-r12, sp, lr}^
	movs pc, lr

yk0a_exception_interrupt_procedure_1:
	mrs r0, cpsr
	ldr r1, =CPSR_OFF
	bic r0, r0, r1
	ldr r1, =CPSR_ON
	orr r0, r0, r1
	msr cpsr, r0

yk0a_exception_interrupt_procedure_2:
	b yk0a_exception_interrupt_procedure_2
