/* (C) 2009-2011 Yana */

#if !defined(YK0A_H)
#define YK0A_H

#include "yk0a_base.h"

#define YK0A_CONTEXT_EPC 0
#define YK0A_CONTEXT_GPR1 1 /* $at */
#define YK0A_CONTEXT_GPR2 2
#define YK0A_CONTEXT_GPR3 3
#define YK0A_CONTEXT_GPR4 4
#define YK0A_CONTEXT_GPR5 5
#define YK0A_CONTEXT_GPR6 6
#define YK0A_CONTEXT_GPR7 7
#define YK0A_CONTEXT_GPR8 8
#define YK0A_CONTEXT_GPR9 9
#define YK0A_CONTEXT_GPR10 10
#define YK0A_CONTEXT_GPR11 11
#define YK0A_CONTEXT_GPR12 12
#define YK0A_CONTEXT_GPR13 13
#define YK0A_CONTEXT_GPR14 14
#define YK0A_CONTEXT_GPR15 15
#define YK0A_CONTEXT_GPR16 16
#define YK0A_CONTEXT_GPR17 17
#define YK0A_CONTEXT_GPR18 18
#define YK0A_CONTEXT_GPR19 19
#define YK0A_CONTEXT_GPR20 20
#define YK0A_CONTEXT_GPR21 21
#define YK0A_CONTEXT_GPR22 22
#define YK0A_CONTEXT_GPR23 23
#define YK0A_CONTEXT_GPR24 24
#define YK0A_CONTEXT_GPR25 25
#define YK0A_CONTEXT_HI 26
#define YK0A_CONTEXT_LO 27
#define YK0A_CONTEXT_GPR28 28 /* $gp */
#define YK0A_CONTEXT_GPR29 29 /* $sp */
#define YK0A_CONTEXT_GPR30 30 /* $fp */
#define YK0A_CONTEXT_GPR31 31 /* $ra */
#define YK0A_CONTEXT_STATUS 32
#define YK0A_CONTEXT_CAUSE 33
#if defined(YK0A_CUSTOM_ENABLE_PORT)
#define YK0A_CUSTOM_CONTEXT_PORT 34
#endif

#define YK0A_CONTEXT_ARGUMENT0 YK0A_CONTEXT_GPR2
#define YK0A_CONTEXT_ARGUMENT1 YK0A_CONTEXT_GPR3
#define YK0A_CONTEXT_ARGUMENT2 YK0A_CONTEXT_GPR4
#define YK0A_CONTEXT_ARGUMENT3 YK0A_CONTEXT_GPR5

#define YK0A_FLAG_KERNEL_MASK (3 << YK0A_FLAG_KERNEL_SHIFT)
#define YK0A_FLAG_KERNEL_SHIFT 30

#define YK0A_FLAG_KERNEL_RECEIVER (2 << YK0A_FLAG_KERNEL_SHIFT)
#define YK0A_FLAG_KERNEL_SENDER (1 << YK0A_FLAG_KERNEL_SHIFT)

#define YK0A_PROCEDURE_ACCEPT 0
#define YK0A_PROCEDURE_BIT_FLAG 1
#define YK0A_PROCEDURE_CALL 2
#define YK0A_PROCEDURE_CONNECT 3
#define YK0A_PROCEDURE_FORWARD 4
#define YK0A_PROCEDURE_GET_CONTEXT 5
#define YK0A_PROCEDURE_GET_PRIORITY 6
#define YK0A_PROCEDURE_LISTEN 7
#define YK0A_PROCEDURE_REPLY 8
#define YK0A_PROCEDURE_SET_CONTEXT 9
#define YK0A_PROCEDURE_SET_PRIORITY 10

#if !defined(YK0A_PREPROCESS_ONLY)

#include <stddef.h>

typedef yk0a_uint32_t yk0a_context_type_t;
typedef yk0a_uint32_t yk0a_context_value_t;
typedef yk0a_uint32_t yk0a_error_t;
typedef yk0a_uint32_t yk0a_flag_t;
typedef yk0a_uint32_t yk0a_port_t;
typedef yk0a_uint32_t yk0a_priority_t;
typedef yk0a_uint32_t yk0a_task_t;

#if defined(YK0A_CUSTOM_DISABLE_ASM)

yk0a_error_t yk0a_accept(yk0a_port_t port, yk0a_task_t *task);
yk0a_error_t yk0a_bit_flag(yk0a_port_t port, yk0a_flag_t flag_off, yk0a_flag_t flag_on, yk0a_flag_t *flag_out);
yk0a_error_t yk0a_call(yk0a_port_t port);
yk0a_error_t yk0a_connect(yk0a_task_t task_replyee, yk0a_task_t task_replyer);
yk0a_error_t yk0a_forward(yk0a_port_t port, yk0a_task_t task);
yk0a_error_t yk0a_get_context(yk0a_task_t task, yk0a_context_type_t type, yk0a_context_value_t *value);
yk0a_error_t yk0a_get_priority(yk0a_task_t task, yk0a_priority_t *priority);
yk0a_error_t yk0a_listen(yk0a_port_t port, yk0a_flag_t flag_wait, yk0a_flag_t *flag_out);
yk0a_error_t yk0a_reply(yk0a_task_t task);
yk0a_error_t yk0a_set_context(yk0a_task_t task, yk0a_context_type_t type, yk0a_context_value_t value_in, yk0a_context_value_t *value_out);
yk0a_error_t yk0a_set_priority(yk0a_task_t task, yk0a_priority_t priority_in, yk0a_priority_t *priority_out);
yk0a_error_t yk0a_get_flag(yk0a_port_t port, yk0a_flag_t *flag);
yk0a_error_t yk0a_set_flag(yk0a_port_t port, yk0a_flag_t flag_in, yk0a_flag_t *flag_out);

#else

__inline__ static yk0a_error_t yk0a_accept(yk0a_port_t port, yk0a_task_t *task) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_ACCEPT;
	register yk0a_uint32_t gpr3 __asm__("$3") = port;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3) : "memory");
	if (task != NULL) {
		*task = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_bit_flag(yk0a_port_t port, yk0a_flag_t flag_off, yk0a_flag_t flag_on, yk0a_flag_t *flag_out) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_BIT_FLAG;
	register yk0a_uint32_t gpr3 __asm__("$3") = port;
	register yk0a_uint32_t gpr4 __asm__("$4") = flag_off;
	register yk0a_uint32_t gpr5 __asm__("$5") = flag_on;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3), "r"(gpr4), "r"(gpr5) : "memory");
	if (flag_out != NULL) {
		*flag_out = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_call(yk0a_port_t port) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_CALL;
	register yk0a_uint32_t gpr3 __asm__("$3") = port;
	__asm__ __volatile__("syscall" : "=r"(gpr2) : "0"(gpr2), "r"(gpr3) : "memory");
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_connect(yk0a_task_t task_replyee, yk0a_task_t task_replyer) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_CONNECT;
	register yk0a_uint32_t gpr3 __asm__("$3") = task_replyee;
	register yk0a_uint32_t gpr4 __asm__("$4") = task_replyer;
	__asm__ __volatile__("syscall" : "=r"(gpr2) : "0"(gpr2), "r"(gpr3), "r"(gpr4) : "memory");
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_forward(yk0a_port_t port, yk0a_task_t task) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_FORWARD;
	register yk0a_uint32_t gpr3 __asm__("$3") = port;
	register yk0a_uint32_t gpr4 __asm__("$4") = task;
	__asm__ __volatile__("syscall" : "=r"(gpr2) : "0"(gpr2), "r"(gpr3), "r"(gpr4) : "memory");
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_get_context(yk0a_task_t task, yk0a_context_type_t type, yk0a_context_value_t *value) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_GET_CONTEXT;
	register yk0a_uint32_t gpr3 __asm__("$3") = task;
	register yk0a_uint32_t gpr4 __asm__("$4") = type;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3), "r"(gpr4) : "memory");
	if (value != NULL) {
		*value = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_get_priority(yk0a_task_t task, yk0a_priority_t *priority) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_GET_PRIORITY;
	register yk0a_uint32_t gpr3 __asm__("$3") = task;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3) : "memory");
	if (priority != NULL) {
		*priority = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_listen(yk0a_port_t port, yk0a_flag_t flag_wait, yk0a_flag_t *flag_out) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_LISTEN;
	register yk0a_uint32_t gpr3 __asm__("$3") = port;
	register yk0a_uint32_t gpr4 __asm__("$4") = flag_wait;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3), "r"(gpr4) : "memory");
	if (flag_out != NULL) {
		*flag_out = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_reply(yk0a_task_t task) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_REPLY;
	register yk0a_uint32_t gpr3 __asm__("$3") = task;
	__asm__ __volatile__("syscall" : "=r"(gpr2) : "0"(gpr2), "r"(gpr3) : "memory");
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_set_context(yk0a_task_t task, yk0a_context_type_t type, yk0a_context_value_t value_in, yk0a_context_value_t *value_out) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_SET_CONTEXT;
	register yk0a_uint32_t gpr3 __asm__("$3") = task;
	register yk0a_uint32_t gpr4 __asm__("$4") = type;
	register yk0a_uint32_t gpr5 __asm__("$5") = value_in;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3), "r"(gpr4), "r"(gpr5) : "memory");
	if (value_out != NULL) {
		*value_out = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_set_priority(yk0a_task_t task, yk0a_priority_t priority_in, yk0a_priority_t *priority_out) {
	register yk0a_uint32_t gpr2 __asm__("$2") = YK0A_PROCEDURE_SET_PRIORITY;
	register yk0a_uint32_t gpr3 __asm__("$3") = task;
	register yk0a_uint32_t gpr4 __asm__("$4") = priority_in;
	__asm__ __volatile__("syscall" : "=r"(gpr2), "=r"(gpr3) : "0"(gpr2), "1"(gpr3), "r"(gpr4) : "memory");
	if (priority_out != NULL) {
		*priority_out = gpr3;
	}
	return gpr2;
}

__inline__ static yk0a_error_t yk0a_get_flag(yk0a_port_t port, yk0a_flag_t *flag) {
	return yk0a_bit_flag(port, 0, 0, flag);
}

__inline__ static yk0a_error_t yk0a_set_flag(yk0a_port_t port, yk0a_flag_t flag_in, yk0a_flag_t *flag_out) {
	return yk0a_bit_flag(port, ~(yk0a_flag_t)0, flag_in, flag_out);
}

#endif

#endif

#endif
