/* (C) 2009-2011 Yana */

#define YK0A_PREPROCESS_ONLY
#include "yk0a_internal.h"
#include "yk0a.h"
#include "yk0a_setup.h"

#define STATUS_KEEP (YK0A_MIPS_STATUS_IM_MASK | YK0A_MIPS_STATUS_ERL | YK0A_MIPS_STATUS_EXL)
#define STATUS_OFF (YK0A_MIPS_STATUS_KSU_MASK | YK0A_MIPS_STATUS_EXL)
#define STATUS_ON YK0A_MIPS_STATUS_IE

#define OFFSET(a) ((a) * 4 + YK0A_CONTEXT_BASE)

	.global yk0a_stack
	.comm yk0a_stack, YK0A_SETUP_STACK_SIZE, YK0A_STACK_ALIGNMENT

	.text
	.balign 4
	.set at
	.set reorder

	.global yk0a_initialize
yk0a_initialize:
	la $gp, _gp
	la $sp, yk0a_stack + YK0A_SETUP_STACK_SIZE / YK0A_STACK_ALIGNMENT * YK0A_STACK_ALIGNMENT - YK0A_STACK_ARGUMENT
	la $2, yk0a_core_initialize
	jr $2

	.global yk0a_exception_interrupt_procedure
yk0a_exception_interrupt_procedure:
	.set noat
	la $kt0, yk0a_schedule_link
	lw $kt0, ($kt0)
	beq $kt0, $0, yk0a_exception_interrupt_procedure_0
	sw $at, OFFSET(YK0A_CONTEXT_GPR1)($kt0)
	.set at
	sw $2, OFFSET(YK0A_CONTEXT_GPR2)($kt0)
	sw $3, OFFSET(YK0A_CONTEXT_GPR3)($kt0)
	sw $4, OFFSET(YK0A_CONTEXT_GPR4)($kt0)
	sw $5, OFFSET(YK0A_CONTEXT_GPR5)($kt0)
	sw $6, OFFSET(YK0A_CONTEXT_GPR6)($kt0)
	sw $7, OFFSET(YK0A_CONTEXT_GPR7)($kt0)
	sw $8, OFFSET(YK0A_CONTEXT_GPR8)($kt0)
	sw $9, OFFSET(YK0A_CONTEXT_GPR9)($kt0)
	sw $10, OFFSET(YK0A_CONTEXT_GPR10)($kt0)
	sw $11, OFFSET(YK0A_CONTEXT_GPR11)($kt0)
	sw $12, OFFSET(YK0A_CONTEXT_GPR12)($kt0)
	sw $13, OFFSET(YK0A_CONTEXT_GPR13)($kt0)
	sw $14, OFFSET(YK0A_CONTEXT_GPR14)($kt0)
	sw $15, OFFSET(YK0A_CONTEXT_GPR15)($kt0)
	sw $16, OFFSET(YK0A_CONTEXT_GPR16)($kt0)
	sw $17, OFFSET(YK0A_CONTEXT_GPR17)($kt0)
	sw $18, OFFSET(YK0A_CONTEXT_GPR18)($kt0)
	sw $19, OFFSET(YK0A_CONTEXT_GPR19)($kt0)
	sw $20, OFFSET(YK0A_CONTEXT_GPR20)($kt0)
	sw $21, OFFSET(YK0A_CONTEXT_GPR21)($kt0)
	sw $22, OFFSET(YK0A_CONTEXT_GPR22)($kt0)
	sw $23, OFFSET(YK0A_CONTEXT_GPR23)($kt0)
	sw $24, OFFSET(YK0A_CONTEXT_GPR24)($kt0)
	sw $25, OFFSET(YK0A_CONTEXT_GPR25)($kt0)
	sw $gp, OFFSET(YK0A_CONTEXT_GPR28)($kt0)
	sw $sp, OFFSET(YK0A_CONTEXT_GPR29)($kt0)
	sw $fp, OFFSET(YK0A_CONTEXT_GPR30)($kt0)
	sw $ra, OFFSET(YK0A_CONTEXT_GPR31)($kt0)
	mfhi $2
	mflo $3
	mfc0 $4, YK0A_MIPS_EPC
	mfc0 $5, YK0A_MIPS_STATUS
	sw $2, OFFSET(YK0A_CONTEXT_HI)($kt0)
	sw $3, OFFSET(YK0A_CONTEXT_LO)($kt0)
	sw $4, OFFSET(YK0A_CONTEXT_EPC)($kt0)
	sw $5, OFFSET(YK0A_CONTEXT_STATUS)($kt0)

yk0a_exception_interrupt_procedure_0:
	la $gp, _gp
	la $sp, yk0a_stack + YK0A_SETUP_STACK_SIZE / YK0A_STACK_ALIGNMENT * YK0A_STACK_ALIGNMENT - YK0A_STACK_ARGUMENT
	la $2, yk0a_core_exception_interrupt_procedure
	jalr $2

	la $kt0, yk0a_schedule_link
	lw $kt0, ($kt0)
	beq $kt0, $0, yk0a_exception_interrupt_procedure_1
	lw $2, OFFSET(YK0A_CONTEXT_HI)($kt0)
	lw $3, OFFSET(YK0A_CONTEXT_LO)($kt0)
	lw $4, OFFSET(YK0A_CONTEXT_EPC)($kt0)
	lw $5, OFFSET(YK0A_CONTEXT_STATUS)($kt0)
	mthi $2
	mtlo $3
	mtc0 $4, YK0A_MIPS_EPC
	YK0A_MIPS_HAZARD_EPC
	mfc0 $2, YK0A_MIPS_STATUS
	li $3, STATUS_KEEP
	and $2, $2, $3
	nor $3, $3, $0
	and $5, $5, $3
	or $2, $2, $5
	mtc0 $2, YK0A_MIPS_STATUS
	YK0A_MIPS_HAZARD_STATUS
	lw $2, OFFSET(YK0A_CONTEXT_GPR2)($kt0)
	lw $3, OFFSET(YK0A_CONTEXT_GPR3)($kt0)
	lw $4, OFFSET(YK0A_CONTEXT_GPR4)($kt0)
	lw $5, OFFSET(YK0A_CONTEXT_GPR5)($kt0)
	lw $6, OFFSET(YK0A_CONTEXT_GPR6)($kt0)
	lw $7, OFFSET(YK0A_CONTEXT_GPR7)($kt0)
	lw $8, OFFSET(YK0A_CONTEXT_GPR8)($kt0)
	lw $9, OFFSET(YK0A_CONTEXT_GPR9)($kt0)
	lw $10, OFFSET(YK0A_CONTEXT_GPR10)($kt0)
	lw $11, OFFSET(YK0A_CONTEXT_GPR11)($kt0)
	lw $12, OFFSET(YK0A_CONTEXT_GPR12)($kt0)
	lw $13, OFFSET(YK0A_CONTEXT_GPR13)($kt0)
	lw $14, OFFSET(YK0A_CONTEXT_GPR14)($kt0)
	lw $15, OFFSET(YK0A_CONTEXT_GPR15)($kt0)
	lw $16, OFFSET(YK0A_CONTEXT_GPR16)($kt0)
	lw $17, OFFSET(YK0A_CONTEXT_GPR17)($kt0)
	lw $18, OFFSET(YK0A_CONTEXT_GPR18)($kt0)
	lw $19, OFFSET(YK0A_CONTEXT_GPR19)($kt0)
	lw $20, OFFSET(YK0A_CONTEXT_GPR20)($kt0)
	lw $21, OFFSET(YK0A_CONTEXT_GPR21)($kt0)
	lw $22, OFFSET(YK0A_CONTEXT_GPR22)($kt0)
	lw $23, OFFSET(YK0A_CONTEXT_GPR23)($kt0)
	lw $24, OFFSET(YK0A_CONTEXT_GPR24)($kt0)
	lw $25, OFFSET(YK0A_CONTEXT_GPR25)($kt0)
	lw $gp, OFFSET(YK0A_CONTEXT_GPR28)($kt0)
	lw $sp, OFFSET(YK0A_CONTEXT_GPR29)($kt0)
	lw $fp, OFFSET(YK0A_CONTEXT_GPR30)($kt0)
	lw $ra, OFFSET(YK0A_CONTEXT_GPR31)($kt0)
	.set noat
	lw $at, OFFSET(YK0A_CONTEXT_GPR1)($kt0)
	eret
	.set at

yk0a_exception_interrupt_procedure_1:
	mfc0 $2, YK0A_MIPS_STATUS
	li $3, ~STATUS_OFF
	and $2, $2, $3
	li $3, STATUS_ON
	or $2, $2, $3
	mtc0 $2, YK0A_MIPS_STATUS
	YK0A_MIPS_HAZARD_STATUS

yk0a_exception_interrupt_procedure_2:
	b yk0a_exception_interrupt_procedure_2
