/* (C) 2009-2011 Yana */

#if !defined(DEVICE_H)
#define DEVICE_H

#if !defined(DEVICE_BASE)
#define DEVICE_BASE 0
#endif

#define DEVICE_CONS_PUTGETCHAR (DEVICE_BASE + 0x10000000)
#define DEVICE_CONS_HALT (DEVICE_BASE + 0x10000010)

#define DEVICE_MP_WHOAMI (DEVICE_BASE + 0x11000000)
#define DEVICE_MP_NCPUS (DEVICE_BASE + 0x11000010)
#define DEVICE_MP_STARTUPCPU (DEVICE_BASE + 0x11000020)
#define DEVICE_MP_STARTUPADDR (DEVICE_BASE + 0x11000030)
#define DEVICE_MP_PAUSE_ADDR (DEVICE_BASE + 0x11000040)
#define DEVICE_MP_PAUSE_CPU (DEVICE_BASE + 0x11000050)
#define DEVICE_MP_UNPAUSE_CPU (DEVICE_BASE + 0x11000060)
#define DEVICE_MP_STARTUPSTACK (DEVICE_BASE + 0x11000070)
#define DEVICE_MP_HARDWARE_RANDOM (DEVICE_BASE + 0x11000080)
#define DEVICE_MP_MEMORY (DEVICE_BASE + 0x11000090)
#define DEVICE_MP_IPI_ONE (DEVICE_BASE + 0x110000a0)
#define DEVICE_MP_IPI_MANY (DEVICE_BASE + 0x110000b0)
#define DEVICE_MP_IPI_READ (DEVICE_BASE + 0x110000c0)
#define DEVICE_MP_NCYCLES (DEVICE_BASE + 0x110000d0)

#define DEVICE_FB_ADDRESS (DEVICE_BASE + 0x12000000)
#define DEVICE_FBCTRL_PORT (DEVICE_BASE + 0x12f00000)
#define DEVICE_FBCTRL_DATA (DEVICE_BASE + 0x12f00010)

#define DEVICE_FBCTRL_NPORTS 8

#define DEVICE_FBCTRL_PORT_COMMAND 0
#define DEVICE_FBCTRL_PORT_X1 1
#define DEVICE_FBCTRL_PORT_Y1 2
#define DEVICE_FBCTRL_PORT_X2 3
#define DEVICE_FBCTRL_PORT_Y2 4
#define DEVICE_FBCTRL_PORT_COLOR_R 5
#define DEVICE_FBCTRL_PORT_COLOR_G 6
#define DEVICE_FBCTRL_PORT_COLOR_B 7

#define DEVICE_FBCTRL_COMMAND_NOP 0
#define DEVICE_FBCTRL_COMMAND_SET_RESOLUTION 1
#define DEVICE_FBCTRL_COMMAND_GET_RESOLUTION 2
#define DEVICE_FBCTRL_COMMAND_FILL 3
#define DEVICE_FBCTRL_COMMAND_COPY 4

#define DEVICE_FBCTRL_MAXY(x) (((0x12f00000 - 0x12000000) / 3) / (x))

#define DEVICE_DISK_OFFSET (DEVICE_BASE + 0x13000000)
#define DEVICE_DISK_OFFSET_HIGH32 (DEVICE_BASE + 0x13000008)
#define DEVICE_DISK_ID (DEVICE_BASE + 0x13000010)
#define DEVICE_DISK_START_OPERATION (DEVICE_BASE + 0x13000020)
#define DEVICE_DISK_STATUS (DEVICE_BASE + 0x13000030)
#define DEVICE_DISK_BUFFER (DEVICE_BASE + 0x13004000)

#define DEVICE_DISK_BUFFER_LEN 0x200

#define DEVICE_DISK_OPERATION_READ 0
#define DEVICE_DISK_OPERATION_WRITE 1

#define DEVICE_ETHER_BUFFER (DEVICE_BASE + 0x14000000)
#define DEVICE_ETHER_STATUS (DEVICE_BASE + 0x14004000)
#define DEVICE_ETHER_PACKETLENGTH (DEVICE_BASE + 0x14004010)
#define DEVICE_ETHER_COMMAND (DEVICE_BASE + 0x14004020)
#define DEVICE_ETHER_MAC (DEVICE_BASE + 0x14004040)

#define DEVICE_ETHER_BUFFER_SIZE 0x4000

#define DEVICE_ETHER_STATUS_MORE_PACKETS_AVAILABLE (1 << 1)
#define DEVICE_ETHER_STATUS_PACKET_RECEIVED (1 << 0)

#define DEVICE_ETHER_COMMAND_RX 0
#define DEVICE_ETHER_COMMAND_TX 1

#define DEVICE_RTC_TRIGGER_READ (DEVICE_BASE + 0x15000000)
#define DEVICE_RTC_SEC (DEVICE_BASE + 0x15000010)
#define DEVICE_RTC_USEC (DEVICE_BASE + 0x15000020)
#define DEVICE_RTC_HZ (DEVICE_BASE + 0x15000100)
#define DEVICE_RTC_INTERRUPT_ACK (DEVICE_BASE + 0x15000110)

#define DEVICE_IRQC_IRQ (DEVICE_BASE + 0x16000000)
#define DEVICE_IRQC_MASK (DEVICE_BASE + 0x16000004)
#define DEVICE_IRQC_UNMASK (DEVICE_BASE + 0x16000008)

#define DEVICE_INTERRUPT_MP (1 << 6)
#define DEVICE_INTERRUPT_RTC (1 << 4)
#define DEVICE_INTERRUPT_ETHER (1 << 3)
#define DEVICE_INTERRUPT_CONS (1 << 2)

#endif
