/* (C) 2009-2011 Yana */

#define Y_PREPROCESS_ONLY
#include "start_setup.h"
#include "y_arm.h"

#define CPSR_OFF Y_ARM_CPSR_M_MASK
#define CPSR_ON (Y_ARM_CPSR_I | Y_ARM_CPSR_F | Y_ARM_CPSR_M_SYS)

#define VECTOR_FROM vector
#define VECTOR_SIZE 0x40
#define VECTOR_TO 0

	.text
	.balign 4

vector:
	ldr pc, vector_0
	ldr pc, vector_1
	ldr pc, vector_2
	ldr pc, vector_3
	ldr pc, vector_4
	ldr pc, vector_5
	ldr pc, vector_6
	ldr pc, vector_7
vector_0:
	.word 0 /* reset */
vector_1:
	.word yk0a_exception_interrupt_procedure
vector_2:
	.word yk0a_exception_interrupt_procedure
vector_3:
	.word yk0a_exception_interrupt_procedure
vector_4:
	.word yk0a_exception_interrupt_procedure
vector_5:
	.word 0 /* reserve */
vector_6:
	.word yk0a_exception_interrupt_procedure
vector_7:
	.word 0 /* fiq */

	.global start
start:
	mrs r0, cpsr
	ldr r1, =CPSR_OFF
	bic r0, r0, r1
	ldr r1, =CPSR_ON
	orr r0, r0, r1
	msr cpsr, r0

	ldr r0, =VECTOR_FROM
	ldr r1, =VECTOR_TO
	ldr r2, =(VECTOR_FROM + VECTOR_SIZE)
start_0:
	ldr r3, [r0], #4
	str r3, [r1], #4
	cmp r0, r2
	bne start_0

	bl yk0a_initialize

	ldr sp, =START_SETUP_TASK0_SP
	ldr lr, =START_SETUP_TASK0_PC
	mrs r0, cpsr
	bic r0, r0, #Y_ARM_CPSR_I
	msr cpsr_c, r0
	mov pc, lr
