/* (C) 2009-2011 Yana */

#if !defined(Y_ARM_H)
#define Y_ARM_H

#include "y_base.h"

#define Y_ARM_CPSR_I (1 << 7)
#define Y_ARM_CPSR_F (1 << 6)
#define Y_ARM_CPSR_M_MASK (0x1f << Y_ARM_CPSR_M_SHIFT)
#define Y_ARM_CPSR_M_SHIFT 0

#define Y_ARM_CPSR_M_IRQ (0x12 << Y_ARM_CPSR_M_SHIFT)
#define Y_ARM_CPSR_M_SVC (0x13 << Y_ARM_CPSR_M_SHIFT)
#define Y_ARM_CPSR_M_SYS (0x1f << Y_ARM_CPSR_M_SHIFT)

#if !defined(Y_PREPROCESS_ONLY)

__inline__ static y_uint32_t y_arm_read_cpsr(void) {
	y_uint32_t cpsr;
	__asm__ __volatile__("mrs %0, cpsr" : "=r"(cpsr));
	return cpsr;
}

__inline__ static void y_arm_write_cpsr(y_uint32_t cpsr) {
	__asm__ __volatile__("msr cpsr, %0" : : "r"(cpsr) : "cc");
}

#endif

#endif
