/* (C) 2009-2011 Yana */

#if !defined(Y_QUEUE_H)
#define Y_QUEUE_H

#include "y_base.h"

#if !defined(Y_PREPROCESS_ONLY)

#include <stddef.h>

typedef struct y_queue {
	struct y_queue *next;
	struct y_queue *previous;
} y_queue_t;

__inline__ static void y_queue_append(y_queue_t *root, y_queue_t *node) {
	node->next = root;
	node->previous = root->previous;
	root->previous->next = node;
	root->previous = node;
}

__inline__ static y_queue_t *y_queue_copy(y_queue_t *root) {
	if (root->next == root) {
		return NULL;
	} else {
		return root->next;
	}
}

__inline__ static void y_queue_delete(y_queue_t *node) {
	node->next->previous = node->previous;
	node->previous->next = node->next;
}

__inline__ static void y_queue_initialize(y_queue_t *root) {
	root->next = root;
	root->previous = root;
}

__inline__ static y_queue_t *y_queue_remove(y_queue_t *root) {
	if (root->next == root) {
		return NULL;
	} else {
		y_queue_t *node;
		node = root->next;
		root->next = node->next;
		node->next->previous = node->previous;
		return node;
	}
}

#endif

#endif
