/* (C) 2009-2011 Yana */

#if !defined(Y_MIPS_H)
#define Y_MIPS_H

#include "y_base.h"

#define Y_MIPS_STATUS $12
#define Y_MIPS_CAUSE $13
#define Y_MIPS_EPC $14

#define Y_MIPS_HAZARD_STATUS ssnop; ssnop
#define Y_MIPS_HAZARD_CAUSE ssnop
#define Y_MIPS_HAZARD_EPC

#define Y_MIPS_STATUS_BEV (1 << 22)
#define Y_MIPS_STATUS_IM_MASK (0xff << Y_MIPS_STATUS_IM_SHIFT)
#define Y_MIPS_STATUS_IM_SHIFT 8
#define Y_MIPS_STATUS_KSU_MASK (3 << Y_MIPS_STATUS_KSU_SHIFT)
#define Y_MIPS_STATUS_KSU_SHIFT 3
#define Y_MIPS_STATUS_ERL (1 << 2)
#define Y_MIPS_STATUS_EXL (1 << 1)
#define Y_MIPS_STATUS_IE (1 << 0)

#define Y_MIPS_CAUSE_BD (1 << 31)
#define Y_MIPS_CAUSE_IV (1 << 23)
#define Y_MIPS_CAUSE_IP_MASK (0xff << Y_MIPS_CAUSE_IP_SHIFT)
#define Y_MIPS_CAUSE_IP_SHIFT 8
#define Y_MIPS_CAUSE_EXCCODE_MASK (0x1f << Y_MIPS_CAUSE_EXCCODE_SHIFT)
#define Y_MIPS_CAUSE_EXCCODE_SHIFT 2

#define Y_MIPS_CAUSE_EXCCODE_INT (0x00 << Y_MIPS_CAUSE_EXCCODE_SHIFT)
#define Y_MIPS_CAUSE_EXCCODE_SYS (0x08 << Y_MIPS_CAUSE_EXCCODE_SHIFT)

#if !defined(Y_PREPROCESS_ONLY)

__inline__ static y_uint32_t y_mips_read_cause(void) {
	y_uint32_t cause;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(Y_MIPS_CAUSE) : "=r"(cause));
	return cause;
}

__inline__ static y_uint32_t y_mips_read_status(void) {
	y_uint32_t status;
	__asm__ __volatile__("mfc0 %0, " Y_PREPROCESS_STRING(Y_MIPS_STATUS) : "=r"(status));
	return status;
}

__inline__ static void y_mips_write_cause(y_uint32_t cause) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(Y_MIPS_CAUSE) "; " Y_PREPROCESS_STRING(Y_MIPS_HAZARD_CAUSE) : : "r"(cause));
}

__inline__ static void y_mips_write_status(y_uint32_t status) {
	__asm__ __volatile__("mtc0 %0, " Y_PREPROCESS_STRING(Y_MIPS_STATUS) "; " Y_PREPROCESS_STRING(Y_MIPS_HAZARD_STATUS) : : "r"(status));
}

#endif

#endif
