/* (C) 2009-2011 Yana */

#include "device.h"
#include "start_setup.h"
#include "y_base.h"
#include "y_device.h"
#include "y_mips.h"
#include "y_yk0a.h"
#include "yk0a.h"
#include "yk0a_interrupt.h"
#include "yk0a_setup.h"
#include <stddef.h>

extern y_uint8_t _gp[];

y_uint8_t task0_stack[TASK0_STACK_SIZE] __attribute__((aligned(Y_STACK_ALIGNMENT)));
y_uint8_t task1_stack[TASK1_STACK_SIZE] __attribute__((aligned(Y_STACK_ALIGNMENT)));

void task1(void);

void task0(void) {
	yk0a_flag_t f;
	yk0a_task_t t;
	y_device_cons_initialize();
	y_yk0a_start(1, task1, task1_stack + TASK1_STACK_SIZE / Y_STACK_ALIGNMENT * Y_STACK_ALIGNMENT - Y_STACK_ARGUMENT, _gp, y_mips_read_status());
	yk0a_listen(YK0A_SETUP_EXCEPTION_PORT, ~YK0A_FLAG_KERNEL_RECEIVER, &f);
	y_device_cons_put_string("{");
	y_device_cons_put_hexadecimal(f);
	if ((f & YK0A_FLAG_KERNEL_SENDER) != 0 && yk0a_accept(YK0A_SETUP_EXCEPTION_PORT, &t) == 0) {
		yk0a_context_value_t cause;
		yk0a_get_context(t, YK0A_CONTEXT_CAUSE, &cause);
		y_device_cons_put_string(" ");
		y_device_cons_put_hexadecimal(t);
		y_device_cons_put_string(" ");
		y_device_cons_put_hexadecimal(cause);
	}
	y_device_cons_put_string("}\n");
	y_device_cons_halt();
}

void task1(void) {
	yk0a_interrupt_bit_mask(0, DEVICE_INTERRUPT_CONS, NULL);
	while (1) {
		yk0a_flag_t f;
		yk0a_listen(YK0A_SETUP_INTERRUPT_PORT, DEVICE_INTERRUPT_CONS, &f);
		if ((f & DEVICE_INTERRUPT_CONS) != 0) {
			y_uint8_t c;
			c = y_device_cons_getchar();
			yk0a_interrupt_bit_mask(0, DEVICE_INTERRUPT_CONS, NULL);
			if (c < ' ') {
				break;
			}
			y_device_cons_putchar(c);
		}
	}
	*(volatile y_uint32_t *)2 = 0;
}
